import * as i0 from '@angular/core';
import { EventEmitter, Component, Output, Input, HostListener, NgModule } from '@angular/core';
import { takeUntilDestroyed } from '@angular/core/rxjs-interop';
import { BehaviorSubject, distinctUntilChanged } from 'rxjs';
import * as i1 from '@angular/common';
import { CommonModule } from '@angular/common';

class BsNavbarTogglerComponent {
    constructor() {
        //#region State
        this.state$ = new BehaviorSubject(false);
        this.stateChange = new EventEmitter();
        //#endregion
        this.toggleOnClick = true;
        this.state$.pipe(distinctUntilChanged(), takeUntilDestroyed())
            .subscribe(state => this.stateChange.emit(state));
    }
    get state() {
        return this.state$.value;
    }
    set state(value) {
        this.state$.next(value);
    }
    toggleState(ev) {
        if (this.toggleOnClick) {
            this.state$.next(!this.state);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.0.3", ngImport: i0, type: BsNavbarTogglerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.0.3", type: BsNavbarTogglerComponent, selector: "bs-navbar-toggler", inputs: { state: "state", toggleOnClick: "toggleOnClick" }, outputs: { stateChange: "stateChange" }, host: { listeners: { "click": "toggleState($event)" } }, ngImport: i0, template: "<div class=\"navbar-toggler float-left\" [class.open]=\"state$ | async\">\n    <div></div>\n    <div></div>\n    <div></div>\n</div>", styles: [":host{align-self:start;top:0;right:0}.navbar-toggler{padding:.75rem 1rem;border:none}.navbar-toggler>div{width:25px;height:2px;background:#bbb;margin:6px 0;transition:.4s}.navbar-toggler.open>div:nth-of-type(1){transform:rotate(-45deg) translate(-7px,5px)}.navbar-toggler.open>div:nth-of-type(2){opacity:0}.navbar-toggler.open>div:nth-of-type(3){transform:rotate(45deg) translate(-6px,-4px)}\n"], dependencies: [{ kind: "pipe", type: i1.AsyncPipe, name: "async" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.0.3", ngImport: i0, type: BsNavbarTogglerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-navbar-toggler', template: "<div class=\"navbar-toggler float-left\" [class.open]=\"state$ | async\">\n    <div></div>\n    <div></div>\n    <div></div>\n</div>", styles: [":host{align-self:start;top:0;right:0}.navbar-toggler{padding:.75rem 1rem;border:none}.navbar-toggler>div{width:25px;height:2px;background:#bbb;margin:6px 0;transition:.4s}.navbar-toggler.open>div:nth-of-type(1){transform:rotate(-45deg) translate(-7px,5px)}.navbar-toggler.open>div:nth-of-type(2){opacity:0}.navbar-toggler.open>div:nth-of-type(3){transform:rotate(45deg) translate(-6px,-4px)}\n"] }]
        }], ctorParameters: () => [], propDecorators: { stateChange: [{
                type: Output
            }], state: [{
                type: Input
            }], toggleOnClick: [{
                type: Input
            }], toggleState: [{
                type: HostListener,
                args: ['click', ['$event']]
            }] } });

class BsNavbarTogglerModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.0.3", ngImport: i0, type: BsNavbarTogglerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.0.3", ngImport: i0, type: BsNavbarTogglerModule, declarations: [BsNavbarTogglerComponent], imports: [CommonModule], exports: [BsNavbarTogglerComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.0.3", ngImport: i0, type: BsNavbarTogglerModule, imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.0.3", ngImport: i0, type: BsNavbarTogglerModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [BsNavbarTogglerComponent],
                    imports: [CommonModule],
                    exports: [BsNavbarTogglerComponent]
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { BsNavbarTogglerComponent, BsNavbarTogglerModule };
//# sourceMappingURL=mintplayer-ng-bootstrap-navbar-toggler.mjs.map
