import * as i0 from '@angular/core';
import { EventEmitter, Component, Output, Input, HostListener, NgModule } from '@angular/core';
import { takeUntilDestroyed } from '@angular/core/rxjs-interop';
import { BehaviorSubject, distinctUntilChanged } from 'rxjs';
import * as i1 from '@angular/common';
import { CommonModule } from '@angular/common';

class BsPlaylistTogglerComponent {
    constructor() {
        //#region State
        this.state$ = new BehaviorSubject(false);
        this.stateChange = new EventEmitter();
        //#endregion
        this.toggleOnClick = true;
        this.state$.pipe(distinctUntilChanged(), takeUntilDestroyed())
            .subscribe(state => this.stateChange.emit(state));
    }
    get state() {
        return this.state$.value;
    }
    set state(value) {
        this.state$.next(value);
    }
    toggleState(ev) {
        if (this.toggleOnClick) {
            this.state$.next(!this.state);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.0.3", ngImport: i0, type: BsPlaylistTogglerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.0.3", type: BsPlaylistTogglerComponent, selector: "bs-playlist-toggler", inputs: { state: "state", toggleOnClick: "toggleOnClick" }, outputs: { stateChange: "stateChange" }, host: { listeners: { "click": "toggleState($event)" } }, ngImport: i0, template: "<div class=\"playlist-toggler float-left\" [class.open]=\"state$ | async\">\n    <div></div>\n    <div></div>\n    <div></div>\n</div>", styles: [".playlist-toggler{width:3.5rem;padding:.75rem}.playlist-toggler>div{width:25px;height:2px;background:#BBB;margin:6px 0;transition:.4s}.playlist-toggler.open>div:nth-of-type(1){transform:rotate(-45deg) translate(-7px,5px)}.playlist-toggler.open>div:nth-of-type(2){transform:rotate(90deg) translateY(14px);opacity:0}.playlist-toggler.open>div:nth-of-type(3){transform:rotate(45deg) translate(-6px,-4px)}.playlist-toggler:not(.open)>div:nth-of-type(1){transform:rotate(-30deg) translate(-10px,11px)}.playlist-toggler:not(.open)>div:nth-of-type(2){transform:rotate(90deg) translateY(14px);opacity:1}.playlist-toggler:not(.open)>div:nth-of-type(3){transform:rotate(30deg) translate(-10px,-11px)}\n"], dependencies: [{ kind: "pipe", type: i1.AsyncPipe, name: "async" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.0.3", ngImport: i0, type: BsPlaylistTogglerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-playlist-toggler', template: "<div class=\"playlist-toggler float-left\" [class.open]=\"state$ | async\">\n    <div></div>\n    <div></div>\n    <div></div>\n</div>", styles: [".playlist-toggler{width:3.5rem;padding:.75rem}.playlist-toggler>div{width:25px;height:2px;background:#BBB;margin:6px 0;transition:.4s}.playlist-toggler.open>div:nth-of-type(1){transform:rotate(-45deg) translate(-7px,5px)}.playlist-toggler.open>div:nth-of-type(2){transform:rotate(90deg) translateY(14px);opacity:0}.playlist-toggler.open>div:nth-of-type(3){transform:rotate(45deg) translate(-6px,-4px)}.playlist-toggler:not(.open)>div:nth-of-type(1){transform:rotate(-30deg) translate(-10px,11px)}.playlist-toggler:not(.open)>div:nth-of-type(2){transform:rotate(90deg) translateY(14px);opacity:1}.playlist-toggler:not(.open)>div:nth-of-type(3){transform:rotate(30deg) translate(-10px,-11px)}\n"] }]
        }], ctorParameters: () => [], propDecorators: { stateChange: [{
                type: Output
            }], state: [{
                type: Input
            }], toggleOnClick: [{
                type: Input
            }], toggleState: [{
                type: HostListener,
                args: ['click', ['$event']]
            }] } });

class BsPlaylistTogglerModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.0.3", ngImport: i0, type: BsPlaylistTogglerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "17.0.3", ngImport: i0, type: BsPlaylistTogglerModule, declarations: [BsPlaylistTogglerComponent], imports: [CommonModule], exports: [BsPlaylistTogglerComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "17.0.3", ngImport: i0, type: BsPlaylistTogglerModule, imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.0.3", ngImport: i0, type: BsPlaylistTogglerModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [BsPlaylistTogglerComponent],
                    imports: [CommonModule],
                    exports: [BsPlaylistTogglerComponent]
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { BsPlaylistTogglerComponent, BsPlaylistTogglerModule };
//# sourceMappingURL=mintplayer-ng-bootstrap-playlist-toggler.mjs.map
